/*
 * EditSquare.java
 *
 * Created on 23 lipiec 2001, 16:25
 */

/**
 *
 * @author  k
 */

import java.awt.*;
import java.awt.event.*;
import java.awt.Graphics2D.*;
import javax.swing.*;
import java.util.*;
  

  public class EditArea extends JComponent
    {
        Image obraz;
        Graphics2D graphics2D;
        
        public NeuronIcon neuronIcon = null;
        public ConnectionIcon connectionIcon = null;
        public NeuralNetEditor ed = null;
  
        private int stare_x;
        private int stare_y;
        private int aktualne_x;
        private int aktualne_y;
        private int aktualny_punkt;
        
        private double x_min;
        private double x_max;
        private double y_min;
        private double y_max;
        
       // public Container zawartosc;
       // public EditSquareBackground editSquareBackground;
        
        public void setNeuronIcons()
        {
            /*this.removeAll();
            for (int i=0; i<c.Points.length; i++)
            {
                NeuronIcon ed = new NeuronIcon();
                this.add(ed);
                ed.num = i;
                ed.setLocation(this.getPixelX(c.Points[i]), this.getPixelY(c.Points[i]));                
            }*/
        }
        
        public void setNeuralNetEditor(NeuralNetEditor ed)
        {
            this.ed = ed;
        }
        
        public int getPixelX(MhPoint p)
        {  
            if ((p.GetX()>=x_min)&&(p.GetX()<=x_max))
            {
                double answer;
                answer = ((double)this.getWidth());
                answer *=(((double)p.GetX())-x_min)/(x_max-x_min);
                return (int)answer;
            }
            else
            {
                return -1; //punkt na pewno poza obszarem wyswietlania
            }
        }
        
        public void setMinY(double y)
        {
            this.y_min = y;
        }
        public void setMinX(double x)
        {
            this.x_min = x;
        }
        public void setMaxY(double y)
        {
            this.y_max = y;
        }
        public void setMaxX(double x)
        {
            this.x_max = x;
        }
         
        public int getPixelY(MhPoint p)
        {           
            if ((p.GetY()>=y_min)&&(p.GetY()<=y_max))
            {
                double answer;
                answer = ((double)this.getHeight());
                answer *=(((double)p.GetY())-y_min)/(y_max-y_min);
                return this.getHeight()-(int)answer;
            }
            else
            {
                return -1; //punkt na pewno poza obszarem wyswietlania
            }
        }
        
        public EditArea(Dimension d){
            //super();
            setDoubleBuffered(false);
            this.setMinimumSize(new Dimension(100, 100));
            this.setSize(d);
            this.setLayout(null);
            this.setBackground(Color.WHITE);
            this.aktualny_punkt = -1;
            
           // editSquareBackground = new EditSquareBackground(d);
          //  editSquareBackground.setSize(d);
          //  NeuronIcon = new NeuronIcon();
           // this.NeuronIcon.setLocation(20,20);
           // this.add(NeuronIcon);
                      
           // this.NeuronIcon.setVisible(true);
           // this.add(editSquareBackground);
            
         //   editSquareBackground.setSize(d);
            
            //System.out.println("EditArea() fired!");
            //System.out.println(d);
            //System.out.println(this.getSize());      
           // System.out.println(this.editSquareBackground.getSize());      

            addMouseListener(new MouseAdapter(){
               public void mousePressed(MouseEvent e){
                   if (e.getButton()==e.BUTTON1)
                   {
                        stare_x = e.getX();
                        stare_y = e.getY();       
                        System.out.println(stare_x);
                        System.out.println(stare_y);
                        String s = (getComponentAt(stare_x,stare_y)).toString();
                   
                        neuronIcon = null;
                   
                        if(getComponentAt(stare_x, stare_y) instanceof NeuronIcon)                   
                        {
                            neuronIcon = (NeuronIcon) getComponentAt(stare_x,stare_y);
                        }
                   
                        System.out.println(s);
                        System.out.println(this.toString());
                   }
                   else
                   {
                       System.out.println("RightClick!");
                       stare_x = e.getX();
                       stare_y = e.getY();   
                       
                        if(getComponentAt(stare_x, stare_y) instanceof NeuronIcon)                   
                        {
                            neuronIcon = (NeuronIcon) getComponentAt(stare_x,stare_y);
                            //niedokonczone!!!
                            if (neuronIcon.ed.network.Neurons[neuronIcon.num] instanceof SigmoidNeuron)
                            {
                                neuronIcon.ed.editSigmoidNeuronDialog.setNeuronIcon(neuronIcon);
                                double force = ((SigmoidNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).force; 
                                double inertia = ((SigmoidNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).inertia; 
                                double sigmo = ((SigmoidNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).sigmo; 
                                boolean opt = ((SigmoidNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).getOptimize(); 
                                neuronIcon.ed.editSigmoidNeuronDialog.setTitle(
                                    "( "
                                    + String.valueOf(neuronIcon.num)
                                    + " )"
                                    +((SigmoidNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).Name);
                                neuronIcon.ed.editSigmoidNeuronDialog.setOptimize(opt);
                                neuronIcon.ed.editSigmoidNeuronDialog.setParams(force, inertia, sigmo);                                
                                neuronIcon.ed.editSigmoidNeuronDialog.show();
                            }
                            else if (neuronIcon.ed.network.Neurons[neuronIcon.num] instanceof SigmoidUnipolarNeuron)
                            {
                                neuronIcon.ed.editSigmoidUnipolarNeuronDialog.setNeuronIcon(neuronIcon);
                                double force = ((SigmoidUnipolarNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).force; 
                                double inertia = ((SigmoidUnipolarNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).inertia; 
                                double sigmo = ((SigmoidUnipolarNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).sigmo;
                                
                                boolean opt = ((SigmoidUnipolarNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).getOptimize(); 
                                neuronIcon.ed.editSigmoidUnipolarNeuronDialog.setOptimize(opt);
                                
                                neuronIcon.ed.editSigmoidUnipolarNeuronDialog.setTitle(
                                    "( "
                                    + String.valueOf(neuronIcon.num)
                                    + " )"
                                    +((SigmoidUnipolarNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).Name);
                                
                                neuronIcon.ed.editSigmoidUnipolarNeuronDialog.setParams(force, inertia, sigmo);
                                neuronIcon.ed.editSigmoidUnipolarNeuronDialog.show();
                            }
                            else if (neuronIcon.ed.network.Neurons[neuronIcon.num] instanceof SinNeuron)
                            {
                                neuronIcon.ed.editSinNeuronDialog.setNeuronIcon(neuronIcon);
                                double f0 = ((SinNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).f0; 
                                double t = ((SinNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).t; 
                                
                                boolean opt = ((SinNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).getOptimize(); 
                                neuronIcon.ed.editSinNeuronDialog.setOptimize(opt);
                                
                                neuronIcon.ed.editSinNeuronDialog.setTitle(
                                    "( "
                                    + String.valueOf(neuronIcon.num)
                                    + " )"
                                    +((SinNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).Name);
                                
                                
                                neuronIcon.ed.editSinNeuronDialog.setParams(f0, t);
                                neuronIcon.ed.editSinNeuronDialog.show();
                            }
                            else if (neuronIcon.ed.network.Neurons[neuronIcon.num] instanceof ConstNeuron)
                            {
                                neuronIcon.ed.editConstNeuronDialog.setNeuronIcon(neuronIcon);
                                double value = ((ConstNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).GetValue(); 
                                boolean opt = ((ConstNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).getOptimize(); 
                                
                                neuronIcon.ed.editConstNeuronDialog.setTitle(
                                    "( "
                                    + String.valueOf(neuronIcon.num)
                                    + " )"
                                    +((ConstNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).Name);
                                
                                
                                neuronIcon.ed.editConstNeuronDialog.setOptimize(opt);
                                neuronIcon.ed.editConstNeuronDialog.setParams(value);
                                neuronIcon.ed.editConstNeuronDialog.show();
                            }
                            else if (neuronIcon.ed.network.Neurons[neuronIcon.num] instanceof DiffNeuron)
                            {
                                neuronIcon.ed.editDiffNeuronDialog.setNeuronIcon(neuronIcon);
                                
                                
                                neuronIcon.ed.editDiffNeuronDialog.setTitle(
                                    "( "
                                    + String.valueOf(neuronIcon.num)
                                    + " )"
                                    +((DiffNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).Name);
                                
                                neuronIcon.ed.editDiffNeuronDialog.show();
                            }
                            else if (neuronIcon.ed.network.Neurons[neuronIcon.num] instanceof RndNeuron)
                            {
                                neuronIcon.ed.editRndNeuronDialog.setNeuronIcon(neuronIcon);
                                
                                neuronIcon.ed.editRndNeuronDialog.setTitle(
                                    "( "
                                    + String.valueOf(neuronIcon.num)
                                    + " )"
                                    +((RndNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).Name);
                                
                                
                                neuronIcon.ed.editRndNeuronDialog.show();

                            }
                            else if (neuronIcon.ed.network.Neurons[neuronIcon.num] instanceof ThresholdNeuron)
                            {
                                neuronIcon.ed.editThresholdNeuronDialog.setNeuronIcon(neuronIcon);
                                double high = ((ThresholdNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).GetHigh(); 
                                double low = ((ThresholdNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).GetLow(); 
                                double thr = ((ThresholdNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).GetThreshold(); 
                                boolean opt = ((ThresholdNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).getOptimize(); 
                                neuronIcon.ed.editThresholdNeuronDialog.setOptimize(opt);
                                neuronIcon.ed.editThresholdNeuronDialog.setParams(high, low, thr);
                                
                                neuronIcon.ed.editThresholdNeuronDialog.setTitle(
                                    "( "
                                    + String.valueOf(neuronIcon.num)
                                    + " )"
                                    +((ThresholdNeuron) neuronIcon.ed.network.Neurons[neuronIcon.num]).Name);
                                
                                
                                neuronIcon.ed.editThresholdNeuronDialog.show();
                            }
                            
                            
                        }
                        else if(getComponentAt(stare_x, stare_y) instanceof ConnectionIcon) 
                        {
                            connectionIcon = (ConnectionIcon) getComponentAt(stare_x,stare_y);
                            System.out.println("Edit Weight !");
                            ed.editConnectionDialog.setConnectionIcon(connectionIcon);
                            boolean opt = ed.network.Wires[connectionIcon.num].getOptimize();
                            double w = ed.network.Wires[connectionIcon.num].weight;
                            ed.editConnectionDialog.setParams(w);
                            ed.editConnectionDialog.setOptimize(opt);
                            ed.editConnectionDialog.setTitle("Edit Weight");
                            ed.editConnectionDialog.show();
                        }
                        else
                        {
                            if (getComponentAt(stare_x, stare_y) instanceof EditArea)
                            {
                                ed.addNeuronDialog.x = stare_x;
                                ed.addNeuronDialog.y = stare_y;
                                ed.addNeuronDialog.show();
                            }
                        }
                   }
              }
            });
            addMouseMotionListener(new MouseMotionAdapter(){
                    public void mouseDragged(MouseEvent e){
                        aktualne_x = e.getX();
                        aktualne_y = e.getY();

                        if (aktualne_x < 0)
                        {
                            aktualne_x = 0;
                        }
                        if (aktualne_y < 0)
                        {
                            aktualne_y = 0;
                        }
                        
                        
                        
                        if (neuronIcon!=null)
                        {
                            neuronIcon.setLocation(aktualne_x,aktualne_y);
                            System.out.println("############################parent:");
                            //System.out.println(neuronIcon.getParent().getParent().getParent().getParent().getParent());
                            neuronIcon.net.Neurons[neuronIcon.num].x = aktualne_x;
                            neuronIcon.net.Neurons[neuronIcon.num].y = aktualne_y;
                            neuronIcon.ed.SetNeuronIcons();
                           /* neuronIcon.getParent().getParent().network.Neurons[neuronIcon.num].x = aktualne_x;
                            neuronIcon.getParent().getParent().network.Neurons[neuronIcon.num].y = aktualne_y;*/
                            
                        }
                        
                        stare_x = aktualne_x;
                        stare_y = aktualne_y;

                        System.out.println("MouseDragged");
                        
                        repaint();
                    }
            });
        }        
        public void paintComponent(Graphics g)
        {
            System.out.println("EditSquare: paintComponent() fired !");
           // this.setSize(tmp_x, tmp_y);
            if (obraz == null)
            {
                obraz = createImage(this.getWidth(), this.getHeight());
    
                System.out.println("Square : obraz==null, ");
                System.out.println(this.getWidth());
                System.out.println(this.getHeight());
                    graphics2D = (Graphics2D) obraz.getGraphics();
                graphics2D.setRenderingHint(RenderingHints.KEY_ANTIALIASING, 
                    RenderingHints.VALUE_ANTIALIAS_ON);
                czysc();
            }          
            g.drawImage(obraz, 0, 0, null);
            int i = this.getComponentCount()-1;
            for (; i>=0; i--)
            {
                Component c = this.getComponent(i);
                c.paint(g);
            }
        }
        public void czysc()
        {
            graphics2D.setPaint(Color.white);
           // graphics2D.fillRect(0,  0,  getSize().width, getSize().height);
          //  System.out.println("Square : czysc() fired!");
          //  System.out.println(getSize().width);
            graphics2D.setPaint(Color.black);
            repaint();
        }
    }
