abstract class Neuron {
        int x;        
        int y;
        int MaxInputs = 1000;
        public WaveformWindow waveDisplay;
        public boolean optimize;
        
        public void setOptimize(boolean b)
        {
            optimize = b;
        }
        public boolean getOptimize()
        {
            return optimize;
        }
        
                
        public void Neuron()
        {
            waveDisplay = new WaveformWindow();
            nInputs = 0;
            Inputs = new Input[MaxInputs];
        }
        
        public String Name="";
	abstract double Evaluate();
        public abstract void AddRandom();
        public double Output=0;
        protected double activation() {
            double a=0;
            for(int i=0; i<this.nInputs; i++)
            {
                a+=Inputs[i].Evaluate();
            }
            return a;
        }
        
        Input [] Inputs;
        public double previousValue=0;
        public int nInputs;
        
        
        public void SetX(int x)
        {
            this.x = x;
        }
        public void SetY(int y)
        {
            this.y = y;
        }
        public int GetX()
        {
            return this.x;
        }
        public int GetY()
        {
            return this.y;
        }   
}