/*
 * ThresholdNeuron.java
 *
 * Created on 16 lipiec 2001, 16:04
 */

/**
 *
 * @author  k
 */
public class ThresholdNeuron extends Neuron {

    private double low,high,threshold;
    public String Name="Thr";
    
    public ThresholdNeuron(double hi, double lo, double thr) {
        waveDisplay = new WaveformWindow();
        waveDisplay.SetNeuronName(Name);
        low = lo;
        high = hi;
        threshold = thr;
    }
    public ThresholdNeuron(double hi, double lo, double thr, WaveformWindow waveDisplay) {
        //waveDisplay = new WaveformWindow();
        //waveDisplay.SetNeuronName(Name);
        this.waveDisplay = waveDisplay;
        low = lo;
        high = hi;
        threshold = thr;
    }
    public void SetLow(double lo)
    {
        low = lo;
    }
    public double GetLow()
    {
        return low;
    }
    public void SetHigh(double hi)
    {
        high = hi;
    }
    public double GetHigh()
    {
        return high;
    }
    public void SetThreshold(double thr)
    {
        threshold = thr;
    }
    public double GetThreshold()
    {
        return threshold;
    }
    public void AddRandom()
    {
        java.util.Random rnd = new java.util.Random(System.currentTimeMillis());
        this.threshold += 1 - 2*rnd.nextDouble();
        this.high += 1 - 2*rnd.nextDouble();
        this.low += 1 - 2*rnd.nextDouble();
    }
    public double Evaluate() {
       if (activation() < threshold)
       {
           Output = low;
       }
       else
       {
           Output = high;
       }
       return Output;
    }  
}
